archives/urls.py
from django.conf.urls import url, include
from . import views

urlpatterns = [
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^list/$', views.ArchiveView.as_view(), name='list'),
    url(r'^user/$', views.UserView.as_view(), name='user'),
    url(r'^add/$', views.CreateArchiveView.as_view(), name='add'),
    url(r'^upload-images/$', views.UploadImageView.as_view(), name='upload-images'),

    url(r'^profile/$', views.ProfileView.as_view(), name='profile-me'),
    url(r'^profile/(?P<uid>\d+)/$', views.ProfileView.as_view(), name='profile'),
    url(r'^profile/detail/$', views.ProfileDetailView.as_view(), name='profile-detail'),
    url(r'^profile/order/$', views.ProfileOrderView.as_view(), name='profile-order'),
    url(r'^profile/edit/$', views.ProfileEditView.as_view(), name='profile-edit'),
    url(r'^profile/post/$', views.ProfilePostView.as_view(), name='profile-post'),

    url(r'^post/(?P<pk>\d+)/$', views.ArchiveDetailView.as_view(), name='detail'),
    url(r'^post/(?P<pk>\d+)/buy/$', views.ArchiveBuyView.as_view(), name='buy'),
    url(r'^post/attach/(?P<pk>\d+)/$', views.AttachmentView.as_view(), name='attachment'),

    url(r'^gift/$', views.GiftListView.as_view(), name='shop'),
    url(r'^gift/(?P<pk>\d+)/$', views.GiftDetailView.as_view(), name='gift'),
    url(r'^gift/(?P<gift_id>\d+)/buy/$', views.OrderCreateView.as_view(), name='order-create'),
    url(r'^gift/order/(?P<pk>\d+)/$', views.OrderDetailView.as_view(), name='order'),

    url(r'^js/$', view=views.JavascriptView.as_view(content_type='text/javascript'), name='js'),
]

mooder/urls.py
import os
from django.conf.urls import url, include
from django.conf.urls.static import static
from django.contrib import admin
from django.conf import settings

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('accounts.urls')),
    url(r'^', include('archives.urls', namespace='archive')),
    url(r'^captcha/', include('captcha.urls')),

    url(r'^management/', include('managements.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/models.py
import urllib, hashlib, os
from uuid import uuid4
from django.db import models
from django.contrib.auth.models import AbstractUser, BaseUserManager, UserManager
from django.conf import settings
from django.db.models.signals import pre_save
from django.shortcuts import reverse
from urllib.parse import urlencode
from django.dispatch import receiver
from django.forms import ValidationError
from archives.models import check_image_extension

from django.conf import settings


class MyUserManager(BaseUserManager):
    def create_user(self, email, nickname, password=None, *args, **kwargs):
        """
        Creates and saves a User with the given email, date of
        birth and password.
        """
        if not email:
            raise ValueError('Users must have an email address')

        user = self.model(
            email=self.normalize_email(email),
            nickname=nickname,
        )
        user.set_password(password)
        user.save(using=self._db)
        return user

    def create_superuser(self, email, nickname, password):
        """
        Creates and saves a superuser with the given email, date of
        birth and password.
        """
        user = self.create_user(
            email,
            password=password,
            nickname=nickname,
        )
        user.is_staff = True
        user.is_superuser = True
        user.save(using=self._db)
        return user


USER_LEVEL = [_[1] for _ in settings.USER_LEVEL_RANGE]
DEFAULT_USER_LEVEL = settings.USER_LEVEL_RANGE[0][1][0]


def generate_upload_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    filename = "%s%s" % (uuid4(), ext)
    return "mugshots/%s/%s" % (instance.id, filename)


# Create your models here.
class Member(AbstractUser):
    username = models.CharField('用户名', max_length=64, blank=True, null=True)
    email = models.EmailField('邮箱', max_length=255, unique=True)
    nickname = models.CharField('昵称', max_length=64, unique=True)
    mugshot = models.ImageField('头像', upload_to=generate_upload_filename, validators=[check_image_extension], blank=True, null=True)
    rank = models.PositiveIntegerField('Rank', default=0)
    coin = models.PositiveIntegerField('金币', default=0)
    level = models.CharField('等级', max_length=16, default=DEFAULT_USER_LEVEL, choices=USER_LEVEL)
    description = models.CharField('个人简介', max_length=512, blank=True, null=True)
    is_auditor = models.BooleanField('审核员', default=False, help_text='是否能够进入审核后台')

    objects = MyUserManager()
    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['nickname']

    class Meta:
        ordering = ['-rank', '-date_joined']

    def get_absolute_url(self):
        return reverse('archive:profile', kwargs=dict(uid=self.id))

    def get_mugshot_url(self):
        if self.mugshot:
            return self.mugshot.url
        else:
            gravatar_url = "//www.gravatar.com/avatar/" + hashlib.md5(self.email.lower().encode()).hexdigest() + "?"
            gravatar_url += urlencode({'s': '100'})
            return gravatar_url


class Invitecode(models.Model):
    code = models.CharField('邀请码', max_length=32, unique=True)
    usedby = models.OneToOneField(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, blank=True, null=True, related_name='used_by_user')
    createdby = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name='created_by_user', blank=True, null=True)
    used = models.BooleanField('使用', default=False)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    used_time = models.DateTimeField('使用时间', blank=True, null=True)

    class Meta:
        ordering = ['-created_time']
        verbose_name = "邀请码"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.code


@receiver(pre_save, sender=Member)
def pre_save_member_receiver(sender, instance, *args, **kwargs):
    for level in settings.USER_LEVEL_RANGE:
        level_name = level[1][0]
        if level[0][0] <= instance.rank < level[0][1] and instance.level != level_name:
            instance.level = level_name
            break

    if instance.rank >= settings.USER_LEVEL_RANGE[-1][0][0]:
        instance.level = settings.USER_LEVEL_RANGE[-1][1][0]

archives/models.py
import io, os
from datetime import datetime
from django.db import models
from django.utils.crypto import get_random_string
from django.conf import settings
from uuid import uuid4
from django.template.defaultfilters import date
from django.utils import timezone
from django.core.exceptions import ValidationError
from django.shortcuts import reverse
from django.db.models.signals import pre_save
from django.dispatch import receiver
from django.templatetags.static import static

__all__ = [
    'VERIFY_STATUS_CHOICES',
    'VISIBLE_STATUS_CHOICES',
    'LEVEL_STATUS_CHOICES',
    'Post',
    'Comment',
    'Category',
    'PostImage',
    'Link',
]

VERIFY_STATUS_CHOICES = (
    ('wait', '待审核'),
    ('pass', '通过'),
    ('failed', '未通过')
)
VISIBLE_STATUS_CHOICES = (
    ('private', '私密的'),
    ('sell', '出售的'),
    ('public', '公开的')
)
LEVEL_STATUS_CHOICES = (
    ('low', '低危'),
    ('medium', '中危'),
    ('high', '高危'),
    ('grave', '严重')
)
generate_random_filename = lambda a,b:b


def check_image_extension(field):
    _allowed_ext = ('.jpg', '.jpeg', '.png', '.bmp', '.gif')
    _, ext = os.path.splitext(field.name)
    ext = ext.lower()
    if ext not in _allowed_ext:
        raise ValidationError("图片文件只允许以下后缀： %s." % (','.join(_allowed_ext), ))


def generate_attachment_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    if ext not in ('.jpg', '.jpeg', '.png', '.bmp', '.gif', '.rar', '.gz', '.zip', '.7z', '.txt', '.pdf',
                   '.doc', '.docx', '.ppt', '.pptx', ):
        ext = '.attach'
    filename = "%s-%s%s" % (uuid4(), get_random_string(length=8), ext)

    tzinfo = timezone.get_current_timezone() if settings.USE_TZ else None
    date_dir = date(datetime.now(tz=tzinfo), 'Y/m')

    return "attachment/%s/%s" % (date_dir, filename)


def generate_image_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    filename = "%s-%s%s" % (uuid4(), get_random_string(length=8), ext)

    tzinfo = timezone.get_current_timezone() if settings.USE_TZ else None
    date_dir = date(datetime.now(tz=tzinfo), 'Y/m/d')

    return "images/%s/%s" % (date_dir, filename)


class FrontPostManager(models.Manager):
    def get_queryset(self):
        return super(FrontPostManager, self).get_queryset().filter(show=True)


# Create your models here.
class Post(models.Model):
    title = models.CharField('标题', max_length=256)
    content = models.TextField('内容', blank=True)
    description = models.TextField('简要描述', blank=True)
    verify = models.CharField('状态', max_length=8, choices=VERIFY_STATUS_CHOICES, default='wait')
    visible = models.CharField('公开度', max_length=8, choices=VISIBLE_STATUS_CHOICES, default='private')
    show = models.BooleanField('显示', default=True)
    rank = models.PositiveIntegerField('Rank', default=0)
    level = models.CharField('等级', max_length=8, choices=LEVEL_STATUS_CHOICES, default='low')
    attachment = models.FileField('附件', blank=True, upload_to=generate_attachment_filename)
    attachment_filename = models.CharField('附件文件名', blank=True, null=True, max_length=256)
    remark = models.TextField('评价', null=True, blank=True)

    price = models.PositiveIntegerField('价格', default=0)
    buyers = models.ManyToManyField(settings.AUTH_USER_MODEL, related_name='user_buy_post', blank=True)

    author = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='作者', on_delete=models.CASCADE, related_name='author_post')
    category = models.ForeignKey('Category', verbose_name='分类', on_delete=models.CASCADE)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    verify_time = models.DateTimeField('审核时间', blank=True, null=True)

    objects = models.Manager()
    posts = FrontPostManager()

    class Meta:
        ordering = ['-created_time']
        verbose_name = "文章"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('archive:detail', kwargs=dict(pk=self.id))

    def get_attachment_url(self):
        return reverse('archive:attachment', kwargs=dict(pk=self.id))


class Comment(models.Model):
    content = models.TextField('评论')
    post = models.ForeignKey(Post, verbose_name='文章', on_delete=models.CASCADE)
    author = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='作者', on_delete=models.CASCADE)
    parent = models.ForeignKey('self', verbose_name='父评论', blank=True, null=True)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['created_time']
        verbose_name = '评论'
        verbose_name_plural = verbose_name

    def __str__(self):
        return "%s's Comment" % self.author.nickname


@receiver(pre_save, sender=Comment)
def pre_save_comment_receiver(sender, instance, *args, **kwargs):
    if instance.parent is None:
        return

    try:
        comment = Comment.objects.get(pk=instance.parent.id)
    except Comment.DoesNotExist:
        instance.parent = None
        return

    if comment.post_id != instance.post_id:
        instance.parent = None


class Category(models.Model):
    name = models.CharField('分类名', max_length=30)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['name']
        verbose_name = "分类"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.name


class PostImage(models.Model):
    file = models.ImageField('图片', upload_to=generate_image_filename, validators=[check_image_extension], blank=True)
    name = models.CharField('文件名', blank=True, null=True, max_length=256)
    uploaded_by = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='上传者', on_delete=models.CASCADE)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    def __str__(self):
        return self.file.url


class Link(models.Model):
    title = models.CharField('名称', max_length=32)
    link = models.URLField('链接')

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['created_time']
        verbose_name = "应用链接"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.title


class Gift(models.Model):
    name = models.CharField('名称', max_length=256)
    link = models.URLField('参考链接', null=True, blank=True)
    photo = models.ImageField('图片', upload_to=generate_image_filename,
                              validators=[check_image_extension], null=True, blank=True)
    description = models.TextField('描述', blank=True)
    price = models.PositiveIntegerField('价格')
    amount = models.PositiveIntegerField('数量', default=0)
    show = models.BooleanField('显示', default=True)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['-price']
        verbose_name = '礼物'
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.name

    def get_photo_url(self):
        if self.photo:
            return self.photo.url
        else:
            return static('img/gift.jpg')

    def get_absolute_url(self):
        return reverse('archive:gift', kwargs=dict(pk=self.id))


class GiftLog(models.Model):
    gift = models.ForeignKey(Gift, verbose_name='礼物')
    buyer = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='购买者')
    cost = models.PositiveIntegerField('花费')
    delivery = models.BooleanField('发货', default=False)

    address = models.CharField('收货地址', max_length=512, help_text='填写收件地址，虚拟物品则填写邮箱或QQ', null=True)
    remark = models.TextField('备注', null=True, blank=True, help_text='没有则无需填写')

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    delivery_time = models.DateTimeField('发货时间', blank=True, null=True)

    reply = models.TextField('管理员回复', null=True, blank=True, help_text='发货订单号等')

    class Meta:
        ordering = ['-created_time']
        verbose_name = '购买记录'
        verbose_name_plural = verbose_name

    def __str__(self):
        return ""

    def get_absolute_url(self):
        return reverse('archive:order', kwargs=dict(pk=self.id))

archives/forms.py
from django import forms
from . import models
from django.core.validators import MinValueValidator, MaxValueValidator
from django .shortcuts import get_object_or_404
from captcha.fields import CaptchaField


class PostForm(forms.ModelForm):
    price = forms.IntegerField(
        validators=[MinValueValidator(0), MaxValueValidator(10)],
        max_value=10,
        min_value=0,
        label='价格',
        initial=0
    )

    def __init__(self, *args, **kwargs):
        super(PostForm, self).__init__(*args, **kwargs)
        for field in self:
            field.view_length = 4

        self['title'].view_length = self['content'].view_length = self['description'].view_length = 12
        self['content'].field.widget.require = False
        self['description'].field.widget.attrs['rows'] = 3

        self['content'].help_text = '使用Markdown编写详情'
        self['description'].help_text = '简要描述一下你的问题，不要透露详情'
        self['attachment'].help_text = '没有附件则无需选择'
        self['price'].help_text = '不出售则无需填写，最多10'

    def clean_price(self):
        if self.cleaned_data['visible'] == 'sell' and self.cleaned_data['price'] <= 0:
            raise forms.ValidationError('出售的贡献必须填写价格')
        return self.cleaned_data['price']

    class Meta:
        model = models.Post
        fields = [
            'title',
            'category',
            'visible',
            'level',
            'price',
            'attachment',
            'description',
            'content',
        ]


class CommentForm(forms.ModelForm):
    class Meta:
        model = models.Comment
        fields = [
            'content',
            'parent'
        ]

    def __init__(self, *args, **kwargs):
        super(CommentForm, self).__init__(*args, **kwargs)

        self['content'].field.widget.attrs['rows'] = 5
        self['parent'].field.widget = forms.HiddenInput()


class PostImageForm(forms.ModelForm):
    class Meta:
        model = models.PostImage
        fields = [
            'file',
            'name',
        ]

templates/archive/_archive_list.html
{% load template_helper %}

<table class="am-table minos-list am-text-sm am-table-bordered am-table-hover am-scrollable-horizontal">
  <tr class="null am-primary">
    <td width="10%" class="am-hide-sm-down">时间</td>
    <td>标题</td>
    <td width="8%" class="am-text-center am-hide-sm-down">等级</td>
    <td width="12%" class="am-text-right">作者</td>
  </tr>
  {% for post in post_list %}
  <tr class="row">
    <td class="am-link-muted am-hide-sm-down">{{ post.created_time | date:'Y-m-d' }}</td>
    <td>
        <a href="{{ post.get_absolute_url }}" >{{ post.title }}</a>
    </td>
    <td class="am-text-center am-hide-sm-down">{{ post.get_level_display | post_tag }}</td>
    <td class="am-text-right"><a href="{{ post.author.get_absolute_url }}">{{ post.author.nickname | truncatechars:13 }}</a></td>
  </tr>
  {% endfor %}
</table>

templates/archive/_user_list.html
{% load template_helper %}

<table class="am-table minos-list am-text-sm am-table-bordered am-table-hover am-scrollable-horizontal">
  <tr class="null am-primary">
    <td class="am-hide-sm-down" width="5%">#</td>
    <td>昵称</td>
    <td width="12%" class="am-text-center">等级</td>
    <td width="5%" class="am-text-right am-hide-sm-down">Rank</td>
  </tr>
  {% for user in member_list %}
  <tr class="row">
    <td class="am-link-muted am-hide-sm-down">{{ forloop.counter }}</td>
    <td>
        <a href="{{ user.get_absolute_url }}" >{{ user.nickname }}</a>
    </td>
    <td class="am-text-center">{{ user.get_level_display | whitehat_tag }}</td>
    <td class="am-text-right am-hide-sm-down">{{ user.rank }}</td>
  </tr>
  {% endfor %}
</table>

templates/archive/detail.html
{% extends 'base.html' %}
{% load static %}
{% load markup_tags %}
{% load html_purifier %}
{% load template_helper %}
{% load permission %}

{% block title %}{{ post.title }}{% endblock %}

{% block header %}
<link rel="stylesheet" href="{% static 'css/code.css' %}">
{% endblock %}

{% block body %}
<div class="am-container">
<div class="am-g">
  <div class="am-u-sm-centered am-u-sm-11">
      <article class="am-article">
          <div class="am-article-hd">
            <h1 class="am-article-title">{{ post.title }}</h1>
          </div>

          <table class="am-table am-table-bordered ">
              <tr>
                  <th>时间</th>
                  <th>作者</th>
                  <th>等级</th>
                  <th>Rank</th>
              </tr>
              <tr>
                  <td>{{ post.created_time | date:'Y-m-d H:i:s' }}</td>
                  <td><a href="{{ post.author.get_absolute_url }}" class="am-link-muted">{{ post.author.nickname }}</a></td>
                  <td class="am-{{ post.level | post_tag_color }}">{{ post.get_level_display }}</td>
                  <td>{{ post.rank }}</td>
              </tr>
            </table>

          <div class="am-article-bd">
            <p class="">{{ post.description | default:'无描述...' | linebreaksbr }}</p>
              <hr>
            {% allow_read_post post=post content=post.content|apply_markup:"markdown"|purifier %}
          </div>

          {% if post.attachment %}
              <hr>
              <h2 class="am-margin-top-xs"><i class="am-icon-paperclip"></i> <a href="{{ post.get_attachment_url }}" class="am-link-muted" target="_blank">附件下载</a></h2>
          {% endif %}
      </article>

      <hr>
      <section class="am-panel am-panel-default">
          <div class="am-panel-bd am-text-sm">
            审核评价： {{ post.remark | default:"没有任何评价..." }}
          </div>
        </section>

      {% if post.comment_set.count > 0 %}<hr>{% endif %}

      {% for comment in post.comment_set.all %}
      <article class="am-comment am-margin-top-lg">
          <a href="{{ comment.author.get_absolute_url }}">
            <img src="{{ comment.author.get_mugshot_url }}" class="am-comment-avatar" width="48" height="48"/>
          </a>

          <div class="am-comment-main">
            <header class="am-comment-hd">
              <div class="am-comment-meta">
                <a href="{{ comment.author.get_absolute_url }}" class="am-comment-author">{{ comment.author.nickname }}</a>
                评论于 <time datetime="{{ comment.created_time }}" title="{{ comment.created_time | date:'Y-m-d H:i:s' }}">{{ comment.created_time | timesince }}</time> 前
              </div>
              <div class="am-g am-comment-meta am-g-collapse am-text-right">

                {% perm 'archives.delete_comment' %}
                <div class="am-fr">
                    <a class="confirm-alert" href="javascript:submit('{% url 'management-comment-delete' pk=comment.id %}')">删除</a>
                </div>
                {% endperm %}
                <div class="am-margin-right-xs am-fr">
                    <a href="javascript:reply('{{ comment.id | escapejs }}', '{{ comment.content | truncatechars:20 | escapejs }}');">回复</a>
                </div>
              </div>
            </header>

            <div class="am-comment-bd">
              {% if comment.parent %}
              <blockquote class="am-margin-bottom-sm">回复 {{ comment.parent.author.nickname }} 的评论 “{{ comment.parent.content | truncatechars:50 }}”</blockquote>
              {% endif %}
              <p>{{ comment.content | linebreaksbr }}</p>
            </div>
          </div>
      </article>
      {% endfor %}

      {% if not is_preview %}
      <hr/>
      <div class="am-panel-bd am-padding-0">
        <div id="reply-box"></div>
        {% for key, value in comment_form.errors.items %}
        <div class="am-alert am-alert-warning am-text-sm" data-am-alert>
          {{ key }}： {{ value }}
        </div>
        {% endfor %}

        <form class="am-form" method="post">
            {% for field in comment_form %}
            {% ifequal field.field.widget.input_type 'hidden' %}
            {{ field }}
            {% else %}
            <div class="am-form-group">
              {% ifnotequal field.name 'captcha' %}<label>{{ field.label }}</label>{% endifnotequal %}
              {{ field | css:"am-form-field" }}
            </div>
            {% endifequal %}
            {% endfor %}
            <div class="am-cf"></div>
            <button type="submit" class="am-btn am-btn-default am-btn-block am-btn-xs am-margin-top">提交</button>
            {% csrf_token %}
        </form>
      </div>
      {% endif %}

  </div>
</div>
</div>
{% endblock %}

{% block footer %}
<script type="text/javascript">
function escape(txt) {
    return txt && txt.replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}
function reply(id, touser) {
    $("#id_parent").val(id);
    touser = escape('回复 “ ' + touser + ' ”');
    touser = $('<div class="am-alert am-text-sm" id="my-alert" data-am-alert><button type="button" class="am-close">&times;</button><p>'+touser+'</p></div>')
    $('#reply-box').html(touser);
    $('#my-alert').on('closed.alert.amui', function() {
      $("#id_parent").val('');
    });
}
</script>
{% endblock %}

templates/archive/my_post.html
{% extends 'base.html' %}
{% load template_helper %}

{% block title %}我的贡献{% endblock %}

{% block body %}
<div class="am-container">
<div class="am-g">
  <div class="am-u-sm-centered am-u-sm-11">
  <h2>我的贡献</h2>
     <hr>

    <table class="am-table minos-list am-text-sm am-table-bordered am-table-hover am-scrollable-horizontal">
      <tr class="null am-primary">
        <td width="10%" class="am-hide-sm-down">时间</td>
        <td>标题</td>
        <td width="8%" class="am-text-center am-hide-sm-down">等级</td>
        <td width="12%" class="am-text-right">状态</td>
      </tr>
      {% for post in post_list %}
      <tr class="row">
        <td class="am-link-muted am-hide-sm-down">{{ post.created_time | date:'Y-m-d' }}</td>
        <td>
            <a href="{{ post.get_absolute_url }}" >
                {{ post.title }}
            </a>
        </td>
        <td class="am-text-center am-hide-sm-down">{{ post.get_level_display | post_tag }}</td>
        <td class="am-text-right">{{ post.get_verify_display }}</td>
      </tr>
      {% endfor %}
    </table>

    {% if is_paginated %}
    {% include 'archive/_pagination.html' %}
    {% endif %}
  </div>
</div>
</div>
{% endblock %}

templates/archive/profile.html
{% extends 'base.html' %}
{% load template_helper %}

{% block title %}{{ member.nickname }} 的个人中心{% endblock %}

{% block body %}
<div class="am-container">
<div class="am-g">
    <div class="am-u-sm-centered am-u-sm-11">
    <div class="am-panel am-panel-default">
      <div class="am-panel-hd">
        <h3 class="am-panel-title am-fl">{{ member.nickname }} 的个人中心</h3>
        {% if request.user.id == member.id %}
        <a class="am-btn am-btn-danger am-btn-xs am-fr" href="{% url 'archive:profile-edit' %}">设置</a>
        {% endif %}
        <div class="am-cf"></div>
      </div>
      <div class="am-panel-bd am-g">
          <div class="am-u-sm-1">
              <img src="{{ member.get_mugshot_url }}" alt="mugshot" width="100" height="100" class="am-img-thumbnail am-circle">
          </div>
          <div class="am-u-sm-11">
                  <blockquote>
              {{ member.description | default:'这个人很懒，没有什么简介。' }}
                  </blockquote>
              <div class="am-g">
                  <div class="am-u-sm-4">
                      Rank： {{ member.rank }}
                  </div>
                  <div class="am-u-sm-4">
                      等级： {{ member.get_level_display | whitehat_tag }}
                  </div>
                  <div class="am-u-sm-4">
                      贡献数： {{ member.author_post.count }}
                  </div>
              </div>
          </div>
      </div>
      <table class="am-table am-text-sm am-table-hover am-scrollable-horizontal">
          <tr class="am-primary">
            <td width="12%" class="am-hide-sm-down">时间</td>
            <td>标题</td>
            <td width="8%" class="am-text-center am-hide-sm-down">等级</td>
            <td class="am-text-right" width="5%">Rank</td>
          </tr>
          {% for post in post_list %}
          <tr>
            <td class="am-link-muted am-hide-sm-down">{{ post.created_time | date:'Y-m-d' }}</td>
            <td>
                <a href="{{ post.get_absolute_url }}" >{{ post.title }}</a>
            </td>
            <td class="am-text-center am-hide-sm-down">{{ post.get_level_display | post_tag }}</td>
            <td class="am-text-right">{{ post.rank }}</td>
          </tr>
          {% endfor %}
      </table>
      {% if is_paginated %}
      <div class="am-panel-footer">
          {% include 'archive/_pagination.html' %}
      </div>
      {% endif %}
    </div>
    </div>
</div>
</div>
{% endblock %}